# NOTE: Ox uses NerdFonts to display icons. You can install nerdfonts from
# https://nerdfonts.com
#
# Download:
# $ wget https://github.com/ryanoasis/nerd-fonts/releases/download/v2.1.0/SourceCodePro.zip
# and unpack to ~/.fonts

%global debug_package %{nil}

Name: ox
Version: 0.2.7
Release: 1%{?dist}
Summary: An independent Rust text editor that runs in your terminal!

License: GPLv2+
URL: https://github.com/curlpipe/ox
Source0: %{url}/archive/%{version}/%{name}-%{version}.tar.gz

%if 0%{?el8}
%else
BuildRequires: cargo >= 1.42
BuildRequires: rust >= 1.42
%endif

%description
Ox is a code editor. It was written in Rust using ANSI escape sequences. It
assists developers with programming by providing several tools to speed up and
make programming easier and a refreshing alternative to heavily bloated and
resource hungry editors such as VS Code and JetBrains. Ox is lightweight so it
can be used on older computers.

Bear in mind, this is a personal project and is nowhere near ready to replace
your existing tools just yet.

It runs in the terminal and runs on platforms like Linux and macOS but doesn't
work on Windows directly (it works if you use WSL) due to a lack of a good
command line. There are many text editors out there and each one of them has
their flaws and I hope to have a text editor that overcomes many of the
burdens and issues.

Ox is not based on any other editor and has been built from the ground up
without any base at all.


%prep
%autosetup -p1
%if 0%{?el8}
curl https://sh.rustup.rs -sSf | sh -s -- --profile minimal -y
%endif


%install
export CARGO_PROFILE_RELEASE_BUILD_OVERRIDE_OPT_LEVEL=3

%if 0%{?el8}
$HOME/.cargo/bin/cargo install --root=%{buildroot}%{_prefix} --path=.
%else
cargo install --root=%{buildroot}%{_prefix} --path=.
%endif

rm -f %{buildroot}%{_prefix}/.crates.toml \
    %{buildroot}%{_prefix}/.crates2.json
strip %{buildroot}%{_bindir}/*


%files
%license LICENSE
%doc README.md tasks.todo.md config/%{name}.ron
%{_bindir}/%{name}


%changelog
* Sun Nov 22 2020 Artem Polishchuk <ego.cordatus@gmail.com> - 0.2.7-1
- build(update): 0.2.7

* Sun Nov  8 2020 Artem - 0.2.6-1
- build(update): 0.2.6

* Thu Nov  5 2020 Artem Polishchuk <ego.cordatus@gmail.com> - 0.2.5-1
- Initial package
